#!/bin/bash
# LT2A
# 27-12-2018
#
l3ri() {
	l3=""
	while [ "$l3" = "" ]; do
		l3=$(zenity --width=350 --title="Introduïu la IP del servidor de centre" --entry --text="Introduïu la IP del servidor del centre" --entry-text="192.168.0.240")
	if [ "$?" = "1" ] ; then
		zenity --error \
		--text="Configuració cancel·lada"
		exit 1
	fi

	done
}


rishimi() {

	smbclient -g -N -L $l3
	if [ $? -ne 0 ]; then
		zenity --error --text="No s'ha pogut realitzar la connexió. La IP introduida és incorrecta"
		exit 1
	fi
	shimi="$(smbclient -g -N -L $l3 2> /dev/null | \
	grep ^Disk | \
        perl -ne 'chomp; @ary = split(m/\|/, $_); print "FALSE\n$ary[1]\n$ary[2]\n";' | \
        zenity --list --width 400 --height 300  --title="Unitats compartides al servidor $l3" \
                --text="Seleccioneu quines unitats voleu muntar" \
                --checklist \
                --column="Muntar-la?" \
                --column="Nom de la unitat" \
                --column="Descripció" \
                --separator=" "
        )"
	if [ -z $shimi ]; then
		zenity --error --text="No has sel·leccionat cap unitat de xarxa"
		exit 1
	fi
}

tegRc() {

	ENTRY=`zenity --width=400 --username --password --title="Usuari per a connectar les unitats"`
	case $? in
         0)
		cuco=$(echo $ENTRY | cut -d'|' -f1)
                cuca=$(echo $ENTRY | cut -d'|' -f2)
		;;
         1)
		echo "S'ha produït un error."
		exit 1;;

        *)
		exit 1;;
	esac
}

desmu() {
	pf=$(md5sum $HOME/.muntador/kirrico | cut -d " " -f 1)
	gpg --batch --passphrase $pf --no-use-agent -d --output $HOME/.muntador/fi $HOME/.muntador/fi.gpg
	l3=$(cat $HOME/.muntador/fi | grep iiiiii | cut -d":" -f 2)
	shimi=$(cat $HOME/.muntador/fi | grep rrrrrr | cut -d":" -f 2)
	for recu in $shimi
	do
		gvfs-mount -u smb://$l3/$recu
	done

}

chiki() {

	if [ -d $HOME/.muntador ]; then

		zenity --question --text="Muntador d'unitats ja s'ha configurat. El vols configurar de nou?"
		if [ $? -eq 0 ]; then
			if [ -f $HOME/.muntador/fi.gpg ]; then 
				desmu
				rm -rf $HOME/.muntador
			fi

		else
			zenity --question --text="Vols desconfigurar-lo? Ja no tindràs més les teves carpetes compartides, però podràs tornar a configurar-lo sempre que vulguis"
			if [ $? -eq 0 ]; then
				desmu
				rm -rf $HOME/.muntador
				zenity --info --text="Desconfigura't correctament"
				exit 1
			else
				zenity --error --text="Configuració cancel·lada"
				exit 1
			fi
		fi
		
	fi

	if [ ! -d $HOME/.muntador ]; then
		mkdir $HOME/.muntador
	fi

	if [ ! -z $HOME/.muntador/kirrico ]; then 
		touch $HOME/.muntador/kirrico
	fi

}

chiki
l3ri
rishimi
tegRc

cuco=$( echo $(echo $ENTRY | cut -d'|' -f1) | base64)
cuca=$( echo $(echo $ENTRY | cut -d'|' -f2) | base64)
echo "iiiiii:$l3" >> $HOME/.muntador/fi
echo "cccccc:$cuco|$cuca" >> $HOME/.muntador/fi
echo "rrrrrr:$shimi" >> $HOME/.muntador/fi
pf=$(md5sum $HOME/.muntador/kirrico | cut -d " " -f 1)
if [ -f $HOME/.muntador/fi.gpg ]; then 
	rm $HOME/.muntador/fi.gpg
fi
gpg --batch --passphrase $pf -c --no-use-agent $HOME/.muntador/fi
rm $HOME/.muntador/fi
/usr/share/lt2a/muntador-unitats/muntador.sh

