#!/bin/bash
# LT2A
# 27-12-2018

munta() {

	var=$(expect -c "
	spawn gvfs-mount smb://$1/$2
	expect \"User *\"
	send -- \"$3\r\"
	expect \"Domain *\"
	send -- \"WORKGROUP\r\"
	expect \"*?assword:*\"
	send -- \"$4\r\"
	expect eof
	")
	echo $var >> /dev/null

}

if [ -d $HOME/.muntador ] && [ -f $HOME/.muntador/fi.gpg ]; then	

	pf=$(md5sum $HOME/.muntador/kirrico | cut -d " " -f 1)
	gpg --batch --passphrase $pf --no-use-agent -d --output $HOME/.muntador/fi $HOME/.muntador/fi.gpg

	l3=$( cat $HOME/.muntador/fi | grep iiiiii | cut -d":" -f 2)
	cuco=$( cat $HOME/.muntador/fi | grep cccccc | cut -d":" -f 2 | cut -d"|" -f 1 | base64 --decode )
	cuca=$( cat $HOME/.muntador/fi | grep cccccc | cut -d":" -f 2 | cut -d"|" -f 2 | base64 --decode )
	shimi=$( cat $HOME/.muntador/fi | grep rrrrrr | cut -d":" -f 2)
	rm $HOME/.muntador/fi


	smbclient -g -N -L $l3
	smberror=$?
	i=0
	while [ $smberror -ne 0 ] && [ $i -lt 120 ]
	do	
		sleep 2
		smbclient -g -N -L $l3
		smberror=$?
		i=$(($i+1))
	done

	if [ $smberror -ne 0 ];then
		exit 1
	fi 

	for recu in $shimi
	do
		munta $l3 $recu $cuco $cuca
	done

	nshimi=$( gvfs-mount -l | grep smb: |cut -d '/' -f 4 | sed ':a;N;$!ba;s/\n/ /g' )
	c_shimi=$( echo $shimi | wc -w)
	c_nshimi=$( echo $nshimi | wc -w)

	if [ $c_nshimi -ne $c_shimi ]; then
		cuco=$( echo $cuco | base64 )
		cuca=$( echo $cuca | base64 )
		echo "iiiiii:$l3" >> $HOME/.muntador/fi
		echo "cccccc:$cuco|$cuca" >> $HOME/.muntador/fi
		echo "rrrrrr:$nshimi" >> $HOME/.muntador/fi
		rm $HOME/.muntador/fi.gpg
		gpg --batch --passphrase $pf -c --no-use-agent $HOME/.muntador/fi
		rm $HOME/.muntador/fi
	fi
fi
